<?php

namespace AFormsEats\App\Admin;

use Aura\Payload_Interface\PayloadStatus as Status;

class OrderList 
{
    protected $session;
    protected $orderRepo;
    const LIMIT = 20;

    public function __construct($session, $orderRepo) 
    {
        $this->session = $session;
        $this->orderRepo = $orderRepo;
    }

    // $_inputs is not sanitized/validated but not used.
    public function __invoke($_inputs, $payload) 
    {
        // authentication
        if (! $this->session->isLoggedIn()) {
            return $payload->setStatus(Status::NOT_AUTHENTICATED);
        }

        // authorization
        if (! $this->session->isAdmin()) {
            return $payload->setStatus(Status::NOT_AUTHORIZED);
        }
        
        $orders = $this->orderRepo->slice(0, self::LIMIT);
        $count = $this->orderRepo->count();
        
        $paging = new \stdClass();
        $paging->lastPage = ceil($count / self::LIMIT);
        $paging->firstPage = 1;
        $paging->page = 1;
        $paging->total = $count;

        return $payload->setStatus(Status::SUCCESS)
                       ->setOutput(array('orders' => $orders, 'paging' => $paging));
    }
}